## x265 1.6

=== source/CMakeLists.txt ===
# vim: syntax=cmake
if(NOT CMAKE_BUILD_TYPE)
    # default to Release build for GCC builds
    set(CMAKE_BUILD_TYPE Release CACHE STRING
        "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel."
        FORCE)
endif()
message(STATUS "cmake version ${CMAKE_VERSION}")
if(POLICY CMP0025)
    cmake_policy(SET CMP0025 OLD) # report Apple's Clang as just Clang
endif()
if(POLICY CMP0042)
    cmake_policy(SET CMP0042 NEW) # MACOSX_RPATH
endif()
if(POLICY CMP0054)
    cmake_policy(SET CMP0054 OLD) # Only interpret if() arguments as variables or keywords when unquoted
endif()

project (x265)
cmake_minimum_required (VERSION 2.8.8) # OBJECT libraries require 2.8.8
include(CheckIncludeFiles)
include(CheckFunctionExists)
include(CheckSymbolExists)
include(CheckCXXCompilerFlag)

option(FPROFILE_GENERATE "Compile executable to generate usage data" OFF)
option(FPROFILE_USE "Compile executable using generated usage data" OFF)
option(NATIVE_BUILD "Target the build CPU" OFF)
option(STATIC_LINK_CRT "Statically link C runtime for release builds" OFF)
mark_as_advanced(FPROFILE_USE FPROFILE_GENERATE NATIVE_BUILD)

# X265_BUILD must be incremented each time the public API is changed
set(X265_BUILD 51)
configure_file("${PROJECT_SOURCE_DIR}/x265.def.in"
               "${PROJECT_BINARY_DIR}/x265.def")
configure_file("${PROJECT_SOURCE_DIR}/x265_config.h.in"
               "${PROJECT_BINARY_DIR}/x265_config.h")

SET(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake" "${CMAKE_MODULE_PATH}")

# System architecture detection
string(TOLOWER "${CMAKE_SYSTEM_PROCESSOR}" SYSPROC)
set(X86_ALIASES x86 i386 i686 x86_64 amd64)
list(FIND X86_ALIASES "${SYSPROC}" X86MATCH)
if("${SYSPROC}" STREQUAL "" OR X86MATCH GREATER "-1")
    message(STATUS "Detected x86 target processor")
    set(X86 1)
    add_definitions(-DX265_ARCH_X86=1)
    if("${CMAKE_SIZEOF_VOID_P}" MATCHES 8)
        set(X64 1)
        add_definitions(-DX86_64=1)
    endif()
elseif(${SYSPROC} STREQUAL "armv6l")
    message(STATUS "Detected ARM target processor")
    set(ARM 1)
    add_definitions(-DX265_ARCH_ARM=1 -DHAVE_ARMV6=1)
else()
    message(STATUS "CMAKE_SYSTEM_PROCESSOR value `${CMAKE_SYSTEM_PROCESSOR}` is unknown")
    message(STATUS "Please add this value near ${CMAKE_CURRENT_LIST_FILE}:${CMAKE_CURRENT_LIST_LINE}")
endif()

if(UNIX)
    list(APPEND PLATFORM_LIBS pthread)
    find_library(LIBRT rt)
    if(LIBRT)
        list(APPEND PLATFORM_LIBS rt)
    endif()
    find_package(Numa)
    if(NUMA_FOUND)
        list(APPEND CMAKE_REQUIRED_LIBRARIES ${NUMA_LIBRARY})
        check_symbol_exists(numa_node_of_cpu numa.h NUMA_V2)
        if(NUMA_V2)
            add_definitions(-DHAVE_LIBNUMA)
            message(STATUS "libnuma found, building with support for NUMA nodes")
            list(APPEND PLATFORM_LIBS ${NUMA_LIBRARY})
            link_directories(${NUMA_LIBRARY_DIR})
            include_directories(${NUMA_INCLUDE_DIR})
        endif()
    endif()
    mark_as_advanced(LIBRT NUMA_FOUND)
endif(UNIX)

if(X64 AND NOT WIN32)
    option(ENABLE_PIC "Enable Position Independent Code" ON)
else()
    option(ENABLE_PIC "Enable Position Independent Code" OFF)
endif(X64 AND NOT WIN32)

# Compiler detection
if(CMAKE_GENERATOR STREQUAL "Xcode")
  set(XCODE 1)
endif()
if (APPLE)
  add_definitions(-DMACOS)
endif()

if(${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
    set(CLANG 1)
endif()
if(${CMAKE_CXX_COMPILER_ID} STREQUAL "Intel")
    set(INTEL_CXX 1)
endif()
if(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
    set(GCC 1)
endif()

if(INTEL_CXX AND WIN32)
    # treat icl roughly like MSVC
    set(MSVC 1)
endif()
if(MSVC)
    if(STATIC_LINK_CRT)
        set(CompilerFlags CMAKE_CXX_FLAGS_RELEASE CMAKE_C_FLAGS_RELEASE)
        foreach(CompilerFlag ${CompilerFlags})
            string(REPLACE "/MD" "/MT" ${CompilerFlag} "${${CompilerFlag}}")
        endforeach()
    endif(STATIC_LINK_CRT)
    add_definitions(/W4)  # Full warnings
    add_definitions(/Ob2) # always inline
    add_definitions(/MP)  # multithreaded build

    # disable Microsofts suggestions for proprietary secure APIs
    add_definitions(/D_CRT_SECURE_NO_WARNINGS)

    check_include_files(stdint.h HAVE_STDINT_H)
    if(NOT HAVE_STDINT_H)
        include_directories(compat/msvc)
    endif()
endif(MSVC)

check_include_files(inttypes.h HAVE_INT_TYPES_H)
if(HAVE_INT_TYPES_H)
    add_definitions(-DHAVE_INT_TYPES_H=1)
endif()

if(INTEL_CXX AND UNIX)
    set(GCC 1) # treat icpc roughly like gcc
elseif(CLANG)
    set(GCC 1) # treat clang roughly like gcc
elseif(CMAKE_COMPILER_IS_GNUCXX)
    set(GCC 1)
endif()
if(GCC)
    add_definitions(-Wall -Wextra -Wshadow)
    add_definitions(-D__STDC_LIMIT_MACROS=1)
    if(ENABLE_PIC)
         add_definitions(-fPIC)
    endif(ENABLE_PIC)
    if(NATIVE_BUILD)
        if(INTEL_CXX)
            add_definitions(-xhost)
        else()
            add_definitions(-march=native)
        endif()
    elseif(X86 AND NOT X64)
        add_definitions(-march=i686)
    endif()
    if(ARM)
        add_definitions(-march=armv6 -mfloat-abi=hard -mfpu=vfp)
    endif()
    if(FPROFILE_GENERATE)
        if(INTEL_CXX)
            add_definitions(-prof-gen -prof-dir="${CMAKE_CURRENT_BINARY_DIR}")
            list(APPEND LINKER_OPTIONS "-prof-gen")
        else()
            check_cxx_compiler_flag(-fprofile-generate CC_HAS_PROFILE_GENERATE)
            if(CC_HAS_PROFILE_GENERATE)
                add_definitions(-fprofile-generate)
                list(APPEND LINKER_OPTIONS "-fprofile-generate")
            endif(CC_HAS_PROFILE_GENERATE)
        endif(INTEL_CXX)
    endif(FPROFILE_GENERATE)
    if(FPROFILE_USE)
        if(INTEL_CXX)
            add_definitions(-prof-use -prof-dir="${CMAKE_CURRENT_BINARY_DIR}")
            list(APPEND LINKER_OPTIONS "-prof-use")
        else()
            check_cxx_compiler_flag(-fprofile-use CC_HAS_PROFILE_USE)
            check_cxx_compiler_flag(-fprofile-correction CC_HAS_PROFILE_CORRECTION)
            check_cxx_compiler_flag(-Wno-error=coverage-mismatch CC_HAS_COVMISMATCH)
            if(CC_HAS_PROFILE_USE)
                add_definitions(-fprofile-use)
                list(APPEND LINKER_OPTIONS "-fprofile-use")
            endif(CC_HAS_PROFILE_USE)
            if(CC_HAS_PROFILE_CORRECTION)
                # auto-correct corrupted counters (happens a lot with x265)
                add_definitions(-fprofile-correction)
            endif(CC_HAS_PROFILE_CORRECTION)
            if(CC_HAS_COVMISMATCH)
                # ignore coverage mismatches (also happens a lot)
                add_definitions(-Wno-error=coverage-mismatch)
            endif(CC_HAS_COVMISMATCH)
        endif(INTEL_CXX)
    endif(FPROFILE_USE)
    if(STATIC_LINK_CRT)
        add_definitions(-static)
        list(APPEND LINKER_OPTIONS "-static")
    endif(STATIC_LINK_CRT)
    check_cxx_compiler_flag(-Wno-narrowing CC_HAS_NO_NARROWING) 
    check_cxx_compiler_flag(-Wno-array-bounds CC_HAS_NO_ARRAY_BOUNDS) 
    if (CC_HAS_NO_ARRAY_BOUNDS)
        add_definitions(-Wno-array-bounds) # these are unhelpful
    endif()
    check_cxx_compiler_flag(-ffast-math CC_HAS_FAST_MATH) 
    if (CC_HAS_FAST_MATH)
        add_definitions(-ffast-math)
    endif()
    check_cxx_compiler_flag(-mstackrealign CC_HAS_STACK_REALIGN) 
    if (CC_HAS_STACK_REALIGN)
        add_definitions(-mstackrealign)
    endif()
    # Disable exceptions. Reduce executable size, increase compability.
    check_cxx_compiler_flag(-fno-exceptions CC_HAS_FNO_EXCEPTIONS_FLAG)
    if(CC_HAS_FNO_EXCEPTIONS_FLAG)
        add_definitions(-fno-exceptions)
    endif()
    set(FSANITIZE "" CACHE STRING "-fsanitize options for GCC/clang")
    if(FSANITIZE)
        add_definitions(-fsanitize=${FSANITIZE})
        # clang and gcc need the sanitize options to be passed at link
        # time so the appropriate ASAN/TSAN runtime libraries can be
        # linked.
        list(APPEND LINKER_OPTIONS "-fsanitize=${FSANITIZE}")
    endif()
    option(ENABLE_AGGRESSIVE_CHECKS "Enable stack protection and -ftrapv" OFF)
    if(ENABLE_AGGRESSIVE_CHECKS)
        # use with care, -ftrapv can cause testbench SIGILL exceptions
        # since it is testing corner cases of signed integer math
        add_definitions(-DUSING_FTRAPV=1)
        check_cxx_compiler_flag(-fsanitize=undefined-trap CC_HAS_CATCH_UNDEFINED) # clang
        check_cxx_compiler_flag(-ftrapv CC_HAS_FTRAPV)                            # gcc
        check_cxx_compiler_flag(-fstack-protector-all CC_HAS_STACK_PROTECT)       # gcc
        if(CC_HAS_FTRAPV)
            add_definitions(-ftrapv)
        endif()
        if(CC_HAS_CATCH_UNDEFINED)
            add_definitions(-fsanitize=undefined-trap -fsanitize-undefined-trap-on-error)
        endif()
        if(CC_HAS_STACK_PROTECT)
            add_definitions(-fstack-protector-all)
            if(MINGW)
                list(APPEND PLATFORM_LIBS ssp)
            endif()
        endif()
    endif(ENABLE_AGGRESSIVE_CHECKS)
    execute_process(COMMAND ${CMAKE_CXX_COMPILER} -dumpversion OUTPUT_VARIABLE CC_VERSION)
endif(GCC)

find_package(Yasm)
if(YASM_FOUND AND X86)
    if (YASM_VERSION_STRING VERSION_LESS "1.2.0")
        message(STATUS "Yasm version ${YASM_VERSION_STRING} is too old. 1.2.0 or later required")
        option(ENABLE_ASSEMBLY "Enable use of assembly coded primitives" OFF)
    else()
        message(STATUS "Found Yasm ${YASM_VERSION_STRING} to build assembly primitives")
        option(ENABLE_ASSEMBLY "Enable use of assembly coded primitives" ON)
    endif()
endif()

option(CHECKED_BUILD "Enable run-time sanity checks (debugging)" OFF)
if(CHECKED_BUILD)
    add_definitions(-DCHECKED_BUILD=1)
endif()

# Build options
set(LIB_INSTALL_DIR lib CACHE STRING "Install location of libraries")
set(BIN_INSTALL_DIR bin CACHE STRING "Install location of executables")

if(X64)
    # NOTE: We only officially support 16bit-per-pixel compiles of x265
    # on 64bit architectures. 16bpp plus large resolution plus slow
    # preset plus 32bit address space usually means malloc failure.  You
    # can disable this if(X64) check if you desparately need a 32bit
    # build with 10bit/12bit support, but this violates the "shrink wrap
    # license" so to speak.  If it breaks you get to keep both halves.
    # You will likely need to compile without assembly
    option(HIGH_BIT_DEPTH "Store pixels as 16bit values" OFF)
endif(X64)
if(HIGH_BIT_DEPTH)
    add_definitions(-DHIGH_BIT_DEPTH=1)
else(HIGH_BIT_DEPTH)
    add_definitions(-DHIGH_BIT_DEPTH=0)
endif(HIGH_BIT_DEPTH)

option(WARNINGS_AS_ERRORS "Stop compiles on first warning" OFF)
if(WARNINGS_AS_ERRORS)
    if(GCC)
        add_definitions(-Werror)
    elseif(MSVC)
        add_definitions(/WX)
    endif()
endif(WARNINGS_AS_ERRORS)

if (WIN32)
    # Visual leak detector
    find_package(VLD QUIET)
    if(VLD_FOUND)
        add_definitions(-DHAVE_VLD)
        include_directories(${VLD_INCLUDE_DIRS})
        list(APPEND PLATFORM_LIBS ${VLD_LIBRARIES})
        link_directories(${VLD_LIBRARY_DIRS})
    endif()
    option(WINXP_SUPPORT "Make binaries compatible with Windows XP" OFF)
    if(WINXP_SUPPORT)
        # force use of workarounds for CONDITION_VARIABLE and atomic
        # intrinsics introduced after XP
        add_definitions(-D_WIN32_WINNT=_WIN32_WINNT_WINXP)
    endif()
endif()

include(version) # determine X265_VERSION and X265_LATEST_TAG
include_directories(. common encoder "${PROJECT_BINARY_DIR}")

option(ENABLE_PPA "Enable PPA profiling instrumentation" OFF)
if(ENABLE_PPA)
    add_definitions(-DENABLE_PPA)
    list(APPEND PLATFORM_LIBS PPA)
    if(UNIX)
        list(APPEND PLATFORM_LIBS dl)
    endif(UNIX)
    add_subdirectory(profile/PPA)
endif(ENABLE_PPA)

option(ENABLE_VTUNE "Enable Vtune profiling instrumentation" OFF)
if(ENABLE_VTUNE)
    add_definitions(-DENABLE_VTUNE)
    include_directories($ENV{VTUNE_AMPLIFIER_XE_2015_DIR}/include)
    list(APPEND PLATFORM_LIBS vtune)

=== debian/changelog ===
x265 (1.6-1) unstable; urgency=medium

  * New upstream release.
  * SONAME bump: libx265-43 -> libx265-51.
  * debian/patches:
    - compile-flags.patch: Refreshed.
    - workaround-partial-SIMD-support.patch, hide-internal-symbol.patch:
      Removed, no longer needed.
  * debian/control: Add libnuma-dev to B-D to build with libnuma support.

 -- Sebastian Ramacher <sramacher@debian.org>  Tue, 07 Apr 2015 23:09:39 +0200

=== debian/control ===
Source: x265
Section: video
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Sebastian Ramacher <sramacher@debian.org>
Build-Depends:
 debhelper (>= 9),
 cmake,
 libnuma-dev [amd64 arm64 i386 mips mipsel powerpc ppc64el],
 yasm (>= 1.2) [any-amd64]
Build-Depends-Indep:
 python-sphinx
Standards-Version: 3.9.6
Homepage: http://x265.org
Vcs-Git: git://anonscm.debian.org/pkg-multimedia/x265.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/x265.git

Package: x265
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: H.265/HEVC video stream encoder
 x265 is a commandline encoder for creating H.265/High Efficency Video Coding
 (HEVC) video streams.
 .
 x265 supports the following features:
  * full prediction and transform quad-tree recursion supported
  * adaptive B-frame placement
  * B-frames as references / arbitrary frame order
  * CABAC (context-based adaptive binary arithmetic coding) entropy coding
  * supports all Intra block types
  * supports all Inter P partitions
  * suports all Inter B partitions from 64x64 down to 8x4
  * weighted prediction for P slices
  * multiple reference frames
  * scenecut detection
  * parallel encoding on multiple CPUs

Package: libx265-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 libx265-51 (= ${binary:Version})
Suggests:
 libx265-doc
Description: H.265/HEVC video stream encoder (development files)
 libx265 is an encoding library for creating H.265/High Efficency Video Coding
 (HEVC) video streams.
 .
 This is the development package which contains headers and libraries for
 libx265.

Package: libx265-51
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Suggests:
 libx265-51-dbg
Description: H.265/HEVC video stream encoder (shared library)
 libx265 is an encoding library for creating H.265/High Efficency Video Coding
 (HEVC) video streams.
 .
 This package contains the shared library.

Package: libx265-51-dbg
Priority: extra
Section: debug
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 libx265-51 (= ${binary:Version})
Description: H.265/HEVC video stream encoder (debugging symbols)
 libx265 is an encoding library for creating H.265/High Efficency Video Coding
 (HEVC) video streams.
 .
 This package provides the debugging symbols for the shared library.

Package: libx265-doc
Section: doc
Architecture: all
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends}
Description: H.265/HEVC video stream encoder (documentation)
 libx265 is an encoding library for creating H.265/High Efficency Video Coding
 (HEVC) video streams.
 .
 This package contains documentation for the command line encoder and the
 shared library.

=== debian/rules ===
#! /usr/bin/make -f

export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed
# LFS support
export DEB_CPPFLAGS_MAINT_APPEND=$(shell getconf LFS_CFLAGS)

DEB_HOST_MULTIARCH=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --parallel --buildsystem=cmake \
		--sourcedirectory=source \
		--builddirectory=x265-8bit

override_dh_auto_clean:
	dh_auto_clean --builddirectory=x265-10bit
	dh_auto_clean
	rm -rf doc/reST/build

override_dh_auto_configure:
	dh_auto_configure --builddirectory=x265-10bit -- \
		-DENABLE_PIC=ON \
		-DHIGH_BIT_DEPTH=ON \
		-DENABLE_CLI=OFF \
		-DLIB_INSTALL_DIR=lib/$(DEB_HOST_MULTIARCH)/x265-10bit
	dh_auto_configure -- \
		-DENABLE_PIC=ON \
		-DLIB_INSTALL_DIR=lib/$(DEB_HOST_MULTIARCH)

override_dh_auto_build-arch:
	dh_auto_build --builddirectory=x265-10bit
	dh_auto_build

override_dh_auto_install-arch:
	dh_auto_install --builddirectory=x265-10bit
	dh_auto_install
	sed -e 's,@DEB_HOST_MULTIARCH@,$(DEB_HOST_MULTIARCH),' \
		debian/x265-10bit.in > debian/tmp/usr/bin/x265-10bit
	chmod a+x debian/tmp/usr/bin/x265-10bit

override_dh_auto_build-indep:
	$(MAKE) -C doc/reST html

override_dh_installdocs-indep:
	dh_installdocs
	dh_sphinxdoc

override_dh_strip:
	dh_strip -plibx265-51 --dbg-package=libx265-51-dbg
	dh_strip --remaining-packages

## x265 1.7

=== source/CMakeLists.txt ===
--- 
+++ 
@@ -30,7 +30,7 @@
 mark_as_advanced(FPROFILE_USE FPROFILE_GENERATE NATIVE_BUILD)
 
 # X265_BUILD must be incremented each time the public API is changed
-set(X265_BUILD 51)
+set(X265_BUILD 59)
 configure_file("${PROJECT_SOURCE_DIR}/x265.def.in"
                "${PROJECT_BINARY_DIR}/x265.def")
 configure_file("${PROJECT_SOURCE_DIR}/x265_config.h.in"
@@ -65,15 +65,19 @@
     if(LIBRT)
         list(APPEND PLATFORM_LIBS rt)
     endif()
+    find_library(LIBDL dl)
+    if(LIBDL)
+        list(APPEND PLATFORM_LIBS dl)
+    endif()
     find_package(Numa)
     if(NUMA_FOUND)
-        list(APPEND CMAKE_REQUIRED_LIBRARIES ${NUMA_LIBRARY})
+        link_directories(${NUMA_LIBRARY_DIR})
+        list(APPEND CMAKE_REQUIRED_LIBRARIES numa)
         check_symbol_exists(numa_node_of_cpu numa.h NUMA_V2)
         if(NUMA_V2)
             add_definitions(-DHAVE_LIBNUMA)
             message(STATUS "libnuma found, building with support for NUMA nodes")
-            list(APPEND PLATFORM_LIBS ${NUMA_LIBRARY})
-            link_directories(${NUMA_LIBRARY_DIR})
+            list(APPEND PLATFORM_LIBS numa)
             include_directories(${NUMA_INCLUDE_DIR})
         endif()
     endif()
@@ -90,7 +94,7 @@
 if(CMAKE_GENERATOR STREQUAL "Xcode")
   set(XCODE 1)
 endif()
-if (APPLE)
+if(APPLE)
   add_definitions(-DMACOS)
 endif()
 
@@ -196,6 +200,7 @@
         add_definitions(-static)
         list(APPEND LINKER_OPTIONS "-static")
     endif(STATIC_LINK_CRT)
+    check_cxx_compiler_flag(-Wno-strict-overflow CC_HAS_NO_STRICT_OVERFLOW)
     check_cxx_compiler_flag(-Wno-narrowing CC_HAS_NO_NARROWING) 
     check_cxx_compiler_flag(-Wno-array-bounds CC_HAS_NO_ARRAY_BOUNDS) 
     if (CC_HAS_NO_ARRAY_BOUNDS)
@@ -291,7 +296,7 @@
     endif()
 endif(WARNINGS_AS_ERRORS)
 
-if (WIN32)
+if(WIN32)
     # Visual leak detector
     find_package(VLD QUIET)
     if(VLD_FOUND)
@@ -300,12 +305,15 @@
         list(APPEND PLATFORM_LIBS ${VLD_LIBRARIES})
         link_directories(${VLD_LIBRARY_DIRS})
     endif()
-    option(WINXP_SUPPORT "Make binaries compatible with Windows XP" OFF)
+    option(WINXP_SUPPORT "Make binaries compatible with Windows XP and Vista" OFF)
     if(WINXP_SUPPORT)
         # force use of workarounds for CONDITION_VARIABLE and atomic
         # intrinsics introduced after XP
-        add_definitions(-D_WIN32_WINNT=_WIN32_WINNT_WINXP)
-    endif()
+        add_definitions(-D_WIN32_WINNT=_WIN32_WINNT_WINXP -D_WIN32_WINNT_WIN7=0x0601)
+    else(WINXP_SUPPORT)
+        # default to targeting Windows 7 for the NUMA APIs
+        add_definitions(-D_WIN32_WINNT=_WIN32_WINNT_WIN7)
+    endif(WINXP_SUPPORT)
 endif()
 
 include(version) # determine X265_VERSION and X265_LATEST_TAG
@@ -318,11 +326,3 @@
     if(UNIX)
         list(APPEND PLATFORM_LIBS dl)
     endif(UNIX)
-    add_subdirectory(profile/PPA)
-endif(ENABLE_PPA)
-
-option(ENABLE_VTUNE "Enable Vtune profiling instrumentation" OFF)
-if(ENABLE_VTUNE)
-    add_definitions(-DENABLE_VTUNE)
-    include_directories($ENV{VTUNE_AMPLIFIER_XE_2015_DIR}/include)
-    list(APPEND PLATFORM_LIBS vtune)

=== source/encoder/CMakeLists.txt ===
# vim: syntax=cmake

if(GCC)
    add_definitions(-Wno-uninitialized)
    if(CC_HAS_NO_STRICT_OVERFLOW)
        # GCC 4.9.2 gives warnings we know we can ignore in this file
        set_source_files_properties(slicetype.cpp PROPERTIES COMPILE_FLAGS -Wno-strict-overflow)
    endif(CC_HAS_NO_STRICT_OVERFLOW)
endif()
if(MSVC)
   add_definitions(/wd4701) # potentially uninitialized local variable 'foo' used
endif()

add_library(encoder OBJECT ../x265.h
    analysis.cpp analysis.h
    search.cpp search.h
    bitcost.cpp bitcost.h rdcost.h
    motion.cpp motion.h
    slicetype.cpp slicetype.h
    frameencoder.cpp frameencoder.h
    framefilter.cpp framefilter.h
    level.cpp level.h
    nal.cpp nal.h
    sei.cpp sei.h
    sao.cpp sao.h
    entropy.cpp entropy.h
    dpb.cpp dpb.h
    ratecontrol.cpp ratecontrol.h
    reference.cpp reference.h
    encoder.cpp encoder.h
    api.cpp
    weightPrediction.cpp)

=== source/test/CMakeLists.txt ===
enable_language(ASM_YASM)

if(MSVC_IDE)
    set(YASM_SRC checkasm-a.obj)
    add_custom_command(
        OUTPUT checkasm-a.obj
        COMMAND ${YASM_EXECUTABLE}
        ARGS ${YASM_FLAGS} ${CMAKE_CURRENT_SOURCE_DIR}/checkasm-a.asm -o checkasm-a.obj
        DEPENDS checkasm-a.asm)
else()
    set(YASM_SRC checkasm-a.asm)
endif()

check_symbol_exists(__rdtsc "intrin.h" HAVE_RDTSC)
if(HAVE_RDTSC)
    add_definitions(-DHAVE_RDTSC=1)
endif()

add_executable(TestBench ${YASM_SRC}
    testbench.cpp testharness.h
    pixelharness.cpp pixelharness.h
    mbdstharness.cpp mbdstharness.h
    ipfilterharness.cpp ipfilterharness.h
    intrapredharness.cpp intrapredharness.h)
target_link_libraries(TestBench x265-static ${PLATFORM_LIBS})
if(LINKER_OPTIONS)
    set_target_properties(TestBench PROPERTIES LINK_FLAGS ${LINKER_OPTIONS})
endif()

=== debian/changelog ===
x265 (1.7-4~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Filippo Giunchedi <filippo@debian.org>  Thu, 03 Sep 2015 13:00:50 +0000

x265 (1.7-4) unstable; urgency=low

  [ Thorsten Glaser ]
  * Fix building on x32 (without asm, for now) (Closes: #792272)

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 19 Jul 2015 13:19:23 +0200

x265 (1.7-3) unstable; urgency=medium

  * debian/rules: Filter -Wl,-Bsymbolic-functions. (Closes: #789111)
  * debian/patches/gcc-check.patch: Apply upstream fix to gcc feature
    detection.

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 19 Jun 2015 15:36:04 +0200

x265 (1.7-2) unstable; urgency=medium

  * Upload to unstable.

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 23 May 2015 14:54:14 +0200

x265 (1.7-1) experimental; urgency=medium

  * New upstream release.
  * SONAME bump: libx265-51 -> libx265-59.
  * debian/patches:
    - compile-flags.patch: Refreshed.
    - highbit-depth-path.patch: Use correct path to lookup 10-bit library.
  * Remove x265-10bit wrapper script. x265 now supports loading the encoder
    for a different bit depth itself.
    - debian/{rules,x265.install,x265.manpages}: Do not build and install
      x265-10bit wrapper script.
    - debian/x26510bit.{in,1}: Removed.

 -- Sebastian Ramacher <sramacher@debian.org>  Thu, 21 May 2015 22:40:21 +0200

=== debian/control ===
--- 
+++ 
@@ -43,7 +43,7 @@
 Multi-Arch: same
 Depends:
  ${misc:Depends},
- libx265-51 (= ${binary:Version})
+ libx265-59 (= ${binary:Version})
 Suggests:
  libx265-doc
 Description: H.265/HEVC video stream encoder (development files)
@@ -53,7 +53,7 @@
  This is the development package which contains headers and libraries for
  libx265.
 
-Package: libx265-51
+Package: libx265-59
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -61,21 +61,21 @@
  ${misc:Depends},
  ${shlibs:Depends}
 Suggests:
- libx265-51-dbg
+ libx265-59-dbg
 Description: H.265/HEVC video stream encoder (shared library)
  libx265 is an encoding library for creating H.265/High Efficency Video Coding
  (HEVC) video streams.
  .
  This package contains the shared library.
 
-Package: libx265-51-dbg
+Package: libx265-59-dbg
 Priority: extra
 Section: debug
 Architecture: any
 Multi-Arch: same
 Depends:
  ${misc:Depends},
- libx265-51 (= ${binary:Version})
+ libx265-59 (= ${binary:Version})
 Description: H.265/HEVC video stream encoder (debugging symbols)
  libx265 is an encoding library for creating H.265/High Efficency Video Coding
  (HEVC) video streams.

=== debian/rules ===
--- 
+++ 
@@ -1,10 +1,13 @@
 #! /usr/bin/make -f
 
+DEB_HOST_MULTIARCH=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+
 export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed
-# LFS support
-export DEB_CPPFLAGS_MAINT_APPEND=$(shell getconf LFS_CFLAGS)
-
-DEB_HOST_MULTIARCH=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
+# see #789111
+export DEB_LDFLAGS_MAINT_STRIP=-Wl,-Bsymbolic-functions
+# LFS support and multiarch path to look up 10bit library
+export DEB_CPPFLAGS_MAINT_APPEND=$(shell getconf LFS_CFLAGS) \
+	-DDEB_HOST_MULTIARCH=\"/usr/lib/$(DEB_HOST_MULTIARCH)/\"
 
 %:
 	dh $@ --parallel --buildsystem=cmake \
@@ -33,9 +36,6 @@
 override_dh_auto_install-arch:
 	dh_auto_install --builddirectory=x265-10bit
 	dh_auto_install
-	sed -e 's,@DEB_HOST_MULTIARCH@,$(DEB_HOST_MULTIARCH),' \
-		debian/x265-10bit.in > debian/tmp/usr/bin/x265-10bit
-	chmod a+x debian/tmp/usr/bin/x265-10bit
 
 override_dh_auto_build-indep:
 	$(MAKE) -C doc/reST html
@@ -45,5 +45,5 @@
 	dh_sphinxdoc
 
 override_dh_strip:
-	dh_strip -plibx265-51 --dbg-package=libx265-51-dbg
+	dh_strip -plibx265-59 --dbg-package=libx265-59-dbg
 	dh_strip --remaining-packages

## x265 1.8

=== source/CMakeLists.txt ===
--- 
+++ 
@@ -30,7 +30,7 @@
 mark_as_advanced(FPROFILE_USE FPROFILE_GENERATE NATIVE_BUILD)
 
 # X265_BUILD must be incremented each time the public API is changed
-set(X265_BUILD 59)
+set(X265_BUILD 68)
 configure_file("${PROJECT_SOURCE_DIR}/x265.def.in"
                "${PROJECT_BINARY_DIR}/x265.def")
 configure_file("${PROJECT_SOURCE_DIR}/x265_config.h.in"
@@ -42,6 +42,8 @@
 string(TOLOWER "${CMAKE_SYSTEM_PROCESSOR}" SYSPROC)
 set(X86_ALIASES x86 i386 i686 x86_64 amd64)
 list(FIND X86_ALIASES "${SYSPROC}" X86MATCH)
+set(POWER_ALIASES ppc64 ppc64le)
+list(FIND POWER_ALIASES "${SYSPROC}" POWERMATCH)
 if("${SYSPROC}" STREQUAL "" OR X86MATCH GREATER "-1")
     message(STATUS "Detected x86 target processor")
     set(X86 1)
@@ -50,6 +52,10 @@
         set(X64 1)
         add_definitions(-DX86_64=1)
     endif()
+elseif(POWERMATCH GREATER "-1")
+    message(STATUS "Detected POWER target processor")
+    set(POWER 1)
+    add_definitions(-DX265_ARCH_POWER=1)
 elseif(${SYSPROC} STREQUAL "armv6l")
     message(STATUS "Detected ARM target processor")
     set(ARM 1)
@@ -82,6 +88,10 @@
         endif()
     endif()
     mark_as_advanced(LIBRT NUMA_FOUND)
+    option(NO_ATOMICS "Use a slow mutex to replace atomics" OFF)
+    if(NO_ATOMICS)
+        add_definitions(-DNO_ATOMICS=1)
+    endif(NO_ATOMICS)
 endif(UNIX)
 
 if(X64 AND NOT WIN32)
@@ -260,6 +270,8 @@
         message(STATUS "Found Yasm ${YASM_VERSION_STRING} to build assembly primitives")
         option(ENABLE_ASSEMBLY "Enable use of assembly coded primitives" ON)
     endif()
+else()
+    option(ENABLE_ASSEMBLY "Enable use of assembly coded primitives" OFF)
 endif()
 
 option(CHECKED_BUILD "Enable run-time sanity checks (debugging)" OFF)
@@ -270,59 +282,37 @@
 # Build options
 set(LIB_INSTALL_DIR lib CACHE STRING "Install location of libraries")
 set(BIN_INSTALL_DIR bin CACHE STRING "Install location of executables")
+set(EXTRA_LIB "" CACHE STRING "Extra libraries to link against")
+set(EXTRA_LINK_FLAGS "" CACHE STRING "Extra link flags")
+if(EXTRA_LINK_FLAGS)
+    list(APPEND LINKER_OPTIONS ${EXTRA_LINK_FLAGS})
+endif()
+if(EXTRA_LIB)
+    option(LINKED_8BIT  "8bit libx265 is being linked with this library" OFF)
+    option(LINKED_10BIT "10bit libx265 is being linked with this library" OFF)
+    option(LINKED_12BIT "12bit libx265 is being linked with this library" OFF)
+endif(EXTRA_LIB)
+mark_as_advanced(EXTRA_LIB EXTRA_LINK_FLAGS)
 
 if(X64)
-    # NOTE: We only officially support 16bit-per-pixel compiles of x265
-    # on 64bit architectures. 16bpp plus large resolution plus slow
+    # NOTE: We only officially support high-bit-depth compiles of x265
+    # on 64bit architectures. Main10 plus large resolution plus slow
     # preset plus 32bit address space usually means malloc failure.  You
     # can disable this if(X64) check if you desparately need a 32bit
     # build with 10bit/12bit support, but this violates the "shrink wrap
     # license" so to speak.  If it breaks you get to keep both halves.
-    # You will likely need to compile without assembly
-    option(HIGH_BIT_DEPTH "Store pixels as 16bit values" OFF)
+    # You will need to disable assembly manually.
+    option(HIGH_BIT_DEPTH "Store pixel samples as 16bit values (Main10/Main12)" OFF)
 endif(X64)
 if(HIGH_BIT_DEPTH)
-    add_definitions(-DHIGH_BIT_DEPTH=1)
+    option(MAIN12 "Support Main12 instead of Main10" OFF)
+    if(MAIN12)
+        add_definitions(-DHIGH_BIT_DEPTH=1 -DX265_DEPTH=12)
+    else()
+        add_definitions(-DHIGH_BIT_DEPTH=1 -DX265_DEPTH=10)
+    endif()
 else(HIGH_BIT_DEPTH)
-    add_definitions(-DHIGH_BIT_DEPTH=0)
+    add_definitions(-DHIGH_BIT_DEPTH=0 -DX265_DEPTH=8)
 endif(HIGH_BIT_DEPTH)
 
-option(WARNINGS_AS_ERRORS "Stop compiles on first warning" OFF)
-if(WARNINGS_AS_ERRORS)
-    if(GCC)
-        add_definitions(-Werror)
-    elseif(MSVC)
-        add_definitions(/WX)
-    endif()
-endif(WARNINGS_AS_ERRORS)
-
-if(WIN32)
-    # Visual leak detector
-    find_package(VLD QUIET)
-    if(VLD_FOUND)
-        add_definitions(-DHAVE_VLD)
-        include_directories(${VLD_INCLUDE_DIRS})
-        list(APPEND PLATFORM_LIBS ${VLD_LIBRARIES})
-        link_directories(${VLD_LIBRARY_DIRS})
-    endif()
-    option(WINXP_SUPPORT "Make binaries compatible with Windows XP and Vista" OFF)
-    if(WINXP_SUPPORT)
-        # force use of workarounds for CONDITION_VARIABLE and atomic
-        # intrinsics introduced after XP
-        add_definitions(-D_WIN32_WINNT=_WIN32_WINNT_WINXP -D_WIN32_WINNT_WIN7=0x0601)
-    else(WINXP_SUPPORT)
-        # default to targeting Windows 7 for the NUMA APIs
-        add_definitions(-D_WIN32_WINNT=_WIN32_WINNT_WIN7)
-    endif(WINXP_SUPPORT)
-endif()
-
-include(version) # determine X265_VERSION and X265_LATEST_TAG
-include_directories(. common encoder "${PROJECT_BINARY_DIR}")
-
-option(ENABLE_PPA "Enable PPA profiling instrumentation" OFF)
-if(ENABLE_PPA)
-    add_definitions(-DENABLE_PPA)
-    list(APPEND PLATFORM_LIBS PPA)
-    if(UNIX)
-        list(APPEND PLATFORM_LIBS dl)
-    endif(UNIX)
+# this option can only be used when linking multiple libx265 libraries

=== debian/changelog ===
x265 (1.8-6) unstable; urgency=medium

  * Move to automatic debug symbol packages.
    - debian/control:
      + B-D on debhelper >= 9.20151219
      + Remove libx265-68-dbg.
    - debian/rules: Run dh_strip with --ddeb-migration.

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 20 Dec 2015 20:36:53 +0100

x265 (1.8-5) unstable; urgency=medium

  * debian/rules: Do not configure, test and install arch bits when building
    indep. (Closes: #806877)
  * debian/control: Enable numa support on mips64 and mipsel64. (Closes:
    #806712)

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 04 Dec 2015 17:58:53 +0100

x265 (1.8-4) unstable; urgency=medium

  * debian/rules: Merge static libraries once cmake is done with them.
    (Closes: #804376)

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 08 Nov 2015 14:34:44 +0100

x265 (1.8-3) unstable; urgency=medium

  * debian/patches
    - fix-linking-with-dl.patch: Fix linking with dl. (Closes: #802093)
    - fix-version-info.patch: Fix version info. (Closes: #802092)

 -- Sebastian Ramacher <sramacher@debian.org>  Tue, 20 Oct 2015 20:59:03 +0200

x265 (1.8-2) unstable; urgency=medium

  * Upload to unstable.

 -- Sebastian Ramacher <sramacher@debian.org>  Wed, 14 Oct 2015 19:35:36 +0200

x265 (1.8-1) experimental; urgency=medium

  * New upstream release.
  * SONAME bump: libx265-59 -> libx265-68.
  * Create multilib build as recommended upstream:
    - debian/rules: Build static versions of 10 bit and 12 bit builds and link
      them into the 8 bit build.
    - debian/patches/highbit-depth-path.patch: Removed, no longer needed.
    - debian/libx265-*.install: No longer install 10 bit build separately.
  * debian/patches: Refresh patches.

 -- Sebastian Ramacher <sramacher@debian.org>  Mon, 12 Oct 2015 01:56:09 +0200

=== debian/control ===
--- 
+++ 
@@ -4,9 +4,9 @@
 Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
 Uploaders: Sebastian Ramacher <sramacher@debian.org>
 Build-Depends:
- debhelper (>= 9),
+ debhelper (>= 9.20151219),
  cmake,
- libnuma-dev [amd64 arm64 i386 mips mipsel powerpc ppc64el],
+ libnuma-dev [amd64 arm64 i386 mips mips64 mips64el mipsel powerpc ppc64el],
  yasm (>= 1.2) [any-amd64]
 Build-Depends-Indep:
  python-sphinx
@@ -43,7 +43,7 @@
 Multi-Arch: same
 Depends:
  ${misc:Depends},
- libx265-59 (= ${binary:Version})
+ libx265-68 (= ${binary:Version})
 Suggests:
  libx265-doc
 Description: H.265/HEVC video stream encoder (development files)
@@ -53,34 +53,18 @@
  This is the development package which contains headers and libraries for
  libx265.
 
-Package: libx265-59
+Package: libx265-68
 Section: libs
 Architecture: any
 Multi-Arch: same
 Depends:
  ${misc:Depends},
  ${shlibs:Depends}
-Suggests:
- libx265-59-dbg
 Description: H.265/HEVC video stream encoder (shared library)
  libx265 is an encoding library for creating H.265/High Efficency Video Coding
  (HEVC) video streams.
  .
  This package contains the shared library.
-
-Package: libx265-59-dbg
-Priority: extra
-Section: debug
-Architecture: any
-Multi-Arch: same
-Depends:
- ${misc:Depends},
- libx265-59 (= ${binary:Version})
-Description: H.265/HEVC video stream encoder (debugging symbols)
- libx265 is an encoding library for creating H.265/High Efficency Video Coding
- (HEVC) video streams.
- .
- This package provides the debugging symbols for the shared library.
 
 Package: libx265-doc
 Section: doc

=== debian/rules ===
#! /usr/bin/make -f

DEB_HOST_MULTIARCH=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed \
	-L$(CURDIR)/x265-10bit \
	-L$(CURDIR)/x265-12bit
# see #789111
export DEB_LDFLAGS_MAINT_STRIP=-Wl,-Bsymbolic-functions
# LFS support
export DEB_CPPFLAGS_MAINT_APPEND=$(shell getconf LFS_CFLAGS)

%:
	dh $@ --parallel --buildsystem=cmake \
		--sourcedirectory=source \
		--builddirectory=x265-8bit

override_dh_auto_clean:
	dh_auto_clean --builddirectory=x265-10bit
	dh_auto_clean --builddirectory=x265-12bit
	dh_auto_clean
	rm -rf doc/reST/build

# -arch bits

override_dh_auto_configure-arch:
	dh_auto_configure --builddirectory=x265-10bit -- \
		-DENABLE_PIC=ON \
		-DENABLE_CLI=OFF \
		-DENABLE_SHARED=OFF \
		-DEXPORT_C_API=OFF \
		-DHIGH_BIT_DEPTH=ON
	dh_auto_configure --builddirectory=x265-12bit -- \
		-DENABLE_PIC=ON \
		-DENABLE_CLI=OFF \
		-DENABLE_SHARED=OFF \
		-DEXPORT_C_API=OFF \
		-DHIGH_BIT_DEPTH=ON \
		-DMAIN12=ON
	dh_auto_configure -- \
		-DENABLE_PIC=ON \
		-DLIB_INSTALL_DIR=lib/$(DEB_HOST_MULTIARCH) \
		-DEXTRA_LIB="x265_main10.a;x265_main12.a" \
		-DLINKED_10BIT=ON \
		-DLINKED_12BIT=ON

override_dh_auto_build-arch:
	dh_auto_build --builddirectory=x265-10bit
	dh_auto_build --builddirectory=x265-12bit
	mv x265-10bit/libx265.a x265-10bit/libx265_main10.a
	mv x265-12bit/libx265.a x265-12bit/libx265_main12.a
	dh_auto_build

override_dh_auto_install-arch:
	dh_auto_install
	ar -M <<EOF \
		CREATE debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libx265.a \
		ADDLIB x265-10bit/libx265_main10.a \
		ADDLIB x265-12bit/libx265_main12.a \
		SAVE \
		END \
EOF

# -indep bits

# no configure, test and install for indep
override_dh_auto_configure-indep override_dh_auto_test-indep override_dh_auto_install-indep:

override_dh_auto_build-indep:
	$(MAKE) -C doc/reST html

override_dh_installdocs-indep:
	dh_installdocs
	dh_sphinxdoc

# common bits

override_dh_strip:
	dh_strip -plibx265-68 --ddeb-migration='libx265-86-dbg (<< 1.8-6~)'
	dh_strip --remaining-packages
